require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe EstrusesController do

  # This should return the minimal set of attributes required to create a valid
  # Estrus. As you add validations to Estrus, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all estruses as @estruses" do
      estrus = Estrus.create! valid_attributes
      get :index
      assigns(:estruses).should eq([estrus])
    end
  end

  describe "GET show" do
    it "assigns the requested estrus as @estrus" do
      estrus = Estrus.create! valid_attributes
      get :show, :id => estrus.id.to_s
      assigns(:estrus).should eq(estrus)
    end
  end

  describe "GET new" do
    it "assigns a new estrus as @estrus" do
      get :new
      assigns(:estrus).should be_a_new(Estrus)
    end
  end

  describe "GET edit" do
    it "assigns the requested estrus as @estrus" do
      estrus = Estrus.create! valid_attributes
      get :edit, :id => estrus.id.to_s
      assigns(:estrus).should eq(estrus)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Estrus" do
        expect {
          post :create, :estrus => valid_attributes
        }.to change(Estrus, :count).by(1)
      end

      it "assigns a newly created estrus as @estrus" do
        post :create, :estrus => valid_attributes
        assigns(:estrus).should be_a(Estrus)
        assigns(:estrus).should be_persisted
      end

      it "redirects to the created estrus" do
        post :create, :estrus => valid_attributes
        response.should redirect_to(Estrus.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved estrus as @estrus" do
        # Trigger the behavior that occurs when invalid params are submitted
        Estrus.any_instance.stub(:save).and_return(false)
        post :create, :estrus => {}
        assigns(:estrus).should be_a_new(Estrus)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Estrus.any_instance.stub(:save).and_return(false)
        post :create, :estrus => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested estrus" do
        estrus = Estrus.create! valid_attributes
        # Assuming there are no other estruses in the database, this
        # specifies that the Estrus created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Estrus.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => estrus.id, :estrus => {'these' => 'params'}
      end

      it "assigns the requested estrus as @estrus" do
        estrus = Estrus.create! valid_attributes
        put :update, :id => estrus.id, :estrus => valid_attributes
        assigns(:estrus).should eq(estrus)
      end

      it "redirects to the estrus" do
        estrus = Estrus.create! valid_attributes
        put :update, :id => estrus.id, :estrus => valid_attributes
        response.should redirect_to(estrus)
      end
    end

    describe "with invalid params" do
      it "assigns the estrus as @estrus" do
        estrus = Estrus.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Estrus.any_instance.stub(:save).and_return(false)
        put :update, :id => estrus.id.to_s, :estrus => {}
        assigns(:estrus).should eq(estrus)
      end

      it "re-renders the 'edit' template" do
        estrus = Estrus.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Estrus.any_instance.stub(:save).and_return(false)
        put :update, :id => estrus.id.to_s, :estrus => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested estrus" do
      estrus = Estrus.create! valid_attributes
      expect {
        delete :destroy, :id => estrus.id.to_s
      }.to change(Estrus, :count).by(-1)
    end

    it "redirects to the estruses list" do
      estrus = Estrus.create! valid_attributes
      delete :destroy, :id => estrus.id.to_s
      response.should redirect_to(estruses_url)
    end
  end

end
